/* slurp-resource.h
 *
 * Copyright © 2017 Julian Richen <julian@richen.io>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SLURP_RESOURCE_H
#define SLURP_RESOURCE_H

#include "slurp-utils.h"

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>

G_BEGIN_DECLS

#define SLURP_TYPE_RESOURCE (slurp_resource_get_type())

G_DECLARE_FINAL_TYPE (SlurpResource, slurp_resource, SLURP, RESOURCE, GObject)

struct _SlurpResource
{
    GObject parent_instance;
};

SlurpResource *
slurp_resource_new (void);

GFile *
slurp_resource_get_source (SlurpResource *self);

void
slurp_resource_set_source (SlurpResource *self,
                           GFile         *source);

void
slurp_resource_set_source_from_uri (SlurpResource *self,
                                    const gchar   *uri);

GFile *
slurp_resource_get_target (SlurpResource *self);

void
slurp_resource_set_target (SlurpResource *self,
                           GFile         *target);

void
slurp_resource_set_target_from_uri (SlurpResource *self,
                                    const gchar   *uri);

gboolean
slurp_resource_get_overwrite (SlurpResource *self);

void
slurp_resource_set_overwrite (SlurpResource *self,
                              gboolean       overwrite);

G_END_DECLS

#endif /* SLURP_RESOURCE_H */

