/* slurp-download-read-data.h
 *
 * Copyright © 2018 Julian Richen <julian@richen.io>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "slurp-resource.h"

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>

G_BEGIN_DECLS

#define SLURP_TYPE_DOWNLOAD_READ_DATA (slurp_download_read_data_get_type())

typedef struct _SlurpDownloadReadData SlurpDownloadReadData;

struct _SlurpDownloadReadData
{
    guint ref_count;

    SlurpResource *resource;
    gchar buffer[6144]; // 6 * 1024
    GInputStream *input;
    GOutputStream *output;
};

SlurpDownloadReadData *
slurp_download_read_data_new (void);

SlurpDownloadReadData *
slurp_download_read_data_copy (SlurpDownloadReadData *self);

SlurpDownloadReadData  *
slurp_download_read_data_ref (SlurpDownloadReadData *self);
void
slurp_download_read_data_unref (SlurpDownloadReadData *self);

G_DEFINE_AUTOPTR_CLEANUP_FUNC (SlurpDownloadReadData, slurp_download_read_data_unref)

G_END_DECLS